<?php

if(isset($_GET['signature']) && isset($_GET['timestamp'])){
  !defined('EMLOG_ROOT') && require_once dirname(__FILE__) . '/../../../init.php';
  new JianAi_weixin();
}

function JianAi_weixin_menu(){
  echo '<div class="sidebarsubmenu" id="JianAi_weixin"><a href="./plugin.php?plugin=JianAi_weixin">微信</a></div>';
}
if(function_exists('addAction')) addAction('adm_sidebar_ext', 'JianAi_weixin_menu');

class JianAi_weixin{

  public function __construct(){

    if(!($this->checkSignature())) emDirect(BLOG_URL);
    if(isset($_GET["echostr"])){
      die($_GET["echostr"]);
    }

    $postStr = isset($GLOBALS["HTTP_RAW_POST_DATA"]) ? trim($GLOBALS["HTTP_RAW_POST_DATA"]) : '';

    if(empty($postStr)) die;
    $postObj  = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);
    $fromUser = $postObj->FromUserName;
    $toUser   = $postObj->ToUserName;

    $keyword  = addslashes(htmlspecialchars(trim($postObj->Content)));
    $keyword  = str_replace(array('%', '_'), array('\%', '\_'), $keyword);
    $db = MySql::getInstance();

    $sqlQueryStr = "SELECT *
FROM " . DB_PREFIX . "blog
WHERE (title LIKE '%$keyword%'
    OR content LIKE '%$keyword%')
  AND type = 'blog'
  AND hide = 'n'
ORDER BY date DESC
LIMIT 6";

    $sql = $db->query($sqlQueryStr);

    $n=0;
    while ($row = $db->fetch_array($sql)) {
      $text = iconv_substr(strip_tags($row['content'],""),0,50,'utf-8');
      $logs[$n][] = $row['title'];
      $logs[$n][] = Url::log($row['gid']);
      $logs[$n][] = $text;

      @ preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $row['content'], $match, PREG_PATTERN_ORDER);

      $img = !empty($match[1][0]) ? $match[1][0] : 'http://www.sharexbar.com/content/plugins/JianAi_weixin/no.jpg';
      $logs[$n][] = $img;
      $n++;
    }
    if(!isset($logs) || empty($logs)){
      $logs = array(
        array('分享巴中欢迎您', BLOG_URL, '分享巴中', BLOG_URL .'content/plugins/JianAi_weixin/no.jpg'),
        array('输入南江  通江 恩阳等关键字看看','http://www.sharexbar.com','分享巴中欢迎您','')
      );
    }

    $textTpl = "<xml>
<ToUserName><![CDATA[%s]]></ToUserName>
<FromUserName><![CDATA[%s]]></FromUserName>
<CreateTime>%s</CreateTime>
<MsgType><![CDATA[%s]]></MsgType>
<ArticleCount>%s</ArticleCount>
<Articles>
";
    $resultStr = sprintf($textTpl, $fromUser, $toUser, time(), "news", count($logs));

    foreach($logs as $k => $v){
      $textTpl = "<item>
<Title><![CDATA[%s]]></Title>
<Description><![CDATA[%s]]></Description>
<PicUrl><![CDATA[%s]]></PicUrl>
<Url><![CDATA[%s]]></Url>
</item>
";
      list($title, $url, $description, $pic) = $v;
      $resultStr .= sprintf($textTpl, $title, $description, $pic, $url);
    }

    $resultStr .= "</Articles>
</xml>";

    echo $resultStr;
    die;
  }

  private function checkSignature(){
    $signature = $_GET["signature"];
    $timestamp = $_GET["timestamp"];
    $nonce = $_GET["nonce"];
    $tmpArr = array("Gou"."Ji_org", $timestamp, $nonce);
    sort($tmpArr, SORT_STRING);
    $tmpStr = implode( $tmpArr );
    $tmpStr = sha1( $tmpStr );

    if( $tmpStr == $signature ){
      return true;
    }else{
      return false;
    }
  }
}

?>